' ========================================================
'
' 	Script Information
'	
'	Title:					Get an Active Directory Security Group SID
'	Author:					Dean Flaming
'	Originally created:	7/8/2010 - 10:15:27
'	Original path:			Get Group SID.vbs
'	Description:			Used for creating a simple form to collect A.D. Group SID values.
'	
' ========================================================
	
'region ScriptForm Designer

'region Constructor

Dim System: Set System = CreateObject("KiXtart.System")

'endregion

'region Post-Constructor Custom Code

'endregion

'region Form Creation
'Warning: It is recommended that changes inside this region be handled using the ScriptForm Designer.
'When working with the ScriptForm designer this region and any changes within may be overwritten.

'~~< GetGroupSidFORM1 >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim GetGroupSidFORM1: Set GetGroupSidFORM1 = System.Form()
GetGroupSidFORM1.Size = System.Size(384, 262)
GetGroupSidFORM1.Icon = System.Icon("ThinApp.ico")
GetGroupSidFORM1.Text = "Get your Group SID"
GetGroupSidForm1.MaximizeBox = False
'~~< GroupSIDLabel >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim GroupSIDLabel: Set GroupSIDLabel = GetGroupSidFORM1.Controls.Label
GroupSIDLabel.Text = "Type in your Domain and Group Name"
GroupSIDLabel.Size = System.Size(343, 23)
GroupSIDLabel.TextAlign = 2
GroupSIDLabel.Location = System.Point(13, 13)
GroupSIDLabel.ImageAlign = 2
GroupSIDLabel.TabStop = False
'~~< DomainNameBox >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim DomainNameBox: Set DomainNameBox = GetGroupSidFORM1.Controls.TextBox
DomainNameBox.Size = System.Size(343, 20)
DomainNameBox.ToolTipText = "Type in your Domain"+Chr(39)+"s FQDN or NetBIOS name here..."
DomainNameBox.Text = "Type your Domain Name here..."
DomainNameBox.Location = System.Point(13, 39)
DomainNameBox.TabStop = True
'~~< GroupNameBox >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim GroupNameBox: Set GroupNameBox = GetGroupSidFORM1.Controls.TextBox
GroupNameBox.Size = System.Size(343, 20)
GroupNameBox.ToolTipText = "Type in your Active Directory Group name here..."
GroupNameBox.Text = "Type your Group Name here..."
GroupNameBox.Location = System.Point(13, 66)
GroupNameBox.TabStop = True
'~~< GetGroupSIDButton >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim GetGroupSIDButton: Set GetGroupSIDButton = GetGroupSidFORM1.Controls.Button
GetGroupSIDButton.Text = "Get Group SID"
GetGroupSIDButton.Size = System.Size(100, 63)
GetGroupSIDButton.Location = System.Point(13, 96)
GetGroupSIDButton.OnClick = "GetGroupSIDValue( GetGroupSIDButton )"
GetGroupSIDButton.Default = True
GetGroupSIDButton.TabStop = True
'~~< ClearFormButton >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim ClearFormButton: Set ClearFormButton = GetGroupSidFORM1.Controls.Button
ClearFormButton.Text = "Clear Form"
ClearFormButton.Size = System.Size(100, 63)
ClearFormButton.Location = System.Point(134, 96)
ClearFormButton.OnClick = "ClearForm( ClearFormButton )"
ClearFormButton.TabStop = True
'~~< GroupSIDOutputLabel >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim GroupSIDOutputLabel: Set GroupSIDOutputLabel = GetGroupSidFORM1.Controls.Label
GroupSIDOutputLabel.Text = "Below is your Group SID Value. Highlight and Copy to use."
GroupSIDOutputLabel.Size = System.Size(343, 23)
GroupSIDOutputLabel.TextAlign = 32
GroupSIDOutputLabel.Location = System.Point(13, 162)
'~~< GroupSID >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim GroupSID: Set GroupSID = GetGroupSidFORM1.Controls.TextBox
GroupSID.Size = System.Size(343, 20)
GroupSID.AcceptsReturn = True
GroupSID.ReadOnly = True
GroupSID.ScrollBars = 3
GroupSID.Location = System.Point(13, 192)
GroupSID.TabStop = True
'~~< ExitButton >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim ExitButton: Set ExitButton = GetGroupSidFORM1.Controls.Button
ExitButton.Text = "Exit"
ExitButton.Size = System.Size(100, 63)
ExitButton.Location = System.Point(256, 96)
ExitButton.TabStop = True
ExitButton.OnClick = "ExitScript( ExitButton )"

'endregion

'region Custom Code

'endregion

'region Event Loop

GetGroupSidFORM1.Visible = True
Do While GetGroupSidFORM1.Visible
	DoEvents = GetGroupSidFORM1.DoEvents
       If DoEvents <> "" Then 
               Execute DoEvents
       End If 
Loop

'endregion

'endregion

'region Event Handlers

Function ExitScript( Object )
	GetGroupSidFORM1.Visible = False
	Exit Function
End Function

Function GetGroupSIDValue( Object )
	On Error Resume Next
	Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	Set objAccount = objWMIService.Get("Win32_Group.Name='" & GroupNameBox.Value & "',Domain='" & DomainNameBox.Value & "'")
	If Err.Number <> 0 Then
		MsgBox "Group '" & GroupNameBox.Value & "' or Domain '" & DomainNameBox.Value & "' does not exist!!", 16, "Non-Existent Domain or Group!"
		Err.Clear
		ClearForm( ClearFormButton )
	Else
		GroupSID.Value = objAccount.SID
	End If
End Function

Function ClearForm( Object )
	GroupSID.Value = ""
	DomainNameBox.Value = ""
	GroupNameBox.Value = ""
End Function

'endregion
